#include <mmach.h>
#include <vipl/vipl.h>

unsigned short *bf;
unsigned char *bf2;
int Xdim, Ydim;

unsigned int getXY(int x, int y) {
  /*if(x>=0 && x<Xdim && y>=0 && y<Ydim)*/
  return( bf[x + y*Xdim] );
  /*else printf("acesso invalido a (%d,%d)\n",x,y);*/
} 


void setXY2(int x, int y, unsigned char val) {
  if(x>=0 && x<Xdim && y>=0 && y<Ydim)
    bf2[x + y*Xdim] = val;
}


void bina(int bin) {
  int x,y;

  for(y=0; y<Ydim; y++) {
    for(x=0; x<Xdim; x++) {
      if (getXY(x,y)<bin) setXY2(x,y,0);
      else setXY2(x,y,255);
    }
  }    
}

int KBina(xvimage *img1, int k, xvimage *img2) {


  switch (img1->data_storage_type) {
    case VFF_TYP_BIT :
      kfprintf(kstderr,"bina: BIT not implemented\n");
      return(0);
      break;

    case VFF_TYP_1_BYTE :
      kfprintf(kstderr, "bina: BYTE not implemented\n");
      return(0);
      break;
 
    case VFF_TYP_2_BYTE :
      Xdim = img1->row_size;
      Ydim = img1->col_size;
      bf = (unsigned short *)(img1->imagedata); 
      bf2 = (unsigned char *)(img2->imagedata);
      bina(k);
      return(1);
      break;

    case VFF_TYP_4_BYTE :
      kfprintf(kstderr,"bina: BYTE4 not implemented\n");
      return(0);
      break;

    case VFF_TYP_FLOAT :
      kfprintf(kstderr,"bina: FLOAT not implemented\n");
      return(0);
      break;

    case VFF_TYP_COMPLEX :
      kfprintf(kstderr,"bina: COMPLEX not implemented\n");
      return(0);
      break;

    case VFF_TYP_DOUBLE :
      kfprintf(kstderr,"bina: DOUBLE not implemented\n");
      return(0);
      break;

    case VFF_TYP_DCOMPLEX :
      kfprintf(kstderr,"bina: COMPLEXD not implemented\n");
      return(0);
      break;

    default:
      kfprintf(kstderr,"bina: Unknown data storage type, %d\n",img1->data_storage_type);
      return(0);
      break;
  }
}


int main(int  argc, char **argv, char **envp) {

xvimage *img1, *img2;
char in[50]; char out[50];


  if (argc!=4){ 
    printf("Uso: comando img_in img_out bin\n",argc,argv[0]);
    exit(0);
  }
  printf("argv[0]=%s in=%s out=%s bin=%d\n",argv[0],argv[1],argv[2],atoi(argv[3]));
  

  sprintf(in,"%s",argv[1]);   sprintf(out,"%s",argv[2]); 

  img1 = readimage(in);

  printf("leu\n");

  if (img1 == NULL)     kexit(1);                    

  img2 = createimage(img1->col_size, img1->row_size, VFF_TYP_1_BYTE, img1->num_of_images,
img1->num_data_bands, img1->comment, img1->map_row_size, img1->map_col_size, img1->map_scheme,
img1->map_storage_type, img1->location_type, img1->location_dim);

  if (img2 == NULL) {
    (void) kfprintf(kstderr, "createimage Failed\n");
    kexit(1);
  }
  
  if (!KBina(img1, atoi(argv[3]), img2)) {
    (void) kfprintf(kstderr, "bina Failed\n");
    kexit(1);
  }
 
  printf("processou\n");

  (void) writeimage(out, img2);  
  
  kexit(KEXIT_SUCCESS);
}


